var modul1 = {

    voltage: {
        min: 0.7,
        max: 3
    },

    resistance: {
        water0: 100,
        applejuice0: 20,
        beer0: 10,
        water1: 80,
        applejuice1: 40,
        beer1: 20
    },

    choice: 'apple juice',
    other: 'alcoholfree beer',

    newChoice() {
        switch(modul1.choice) {
            case 'apple juice':
                modul1.datas.author = modul1.datas.beerAuthor;
                modul1.other = 'alcoholfree beer';
                break;
            case 'alcoholfree beer':
                modul1.datas.author = modul1.datas.applejuiceAuthor;
                modul1.other = 'apple juice';
                break;
        }
    },

    datas: {
        water: [],
        other: [],
        author: [[0.8,18.5], [1,10.1], [1.2,6.9], [1.4,5.8], [1.6,6.0], [1.8,7.1], [2,9.9], [2.2,17.2], [2.4,37.5], [2.6,93.5], [2.8,175]],
        beerAuthor: [[0.8,18.5], [1,10.1], [1.2,6.9], [1.4,5.8], [1.6,6.0], [1.8,7.1], [2,9.9], [2.2,17.2], [2.4,37.5], [2.6,93.5], [2.8,175]],
        applejuiceAuthor: [[0.8,6.9], [1,4.2], [1.2,2.6], [1.4,2.0], [1.6,2.1], [1.8,2.0], [2,2.0], [2.2,2.4], [2.4,3.5], [2.6,8.3], [2.8,22.2]]
    },


    updateBars() {
        var maxWidth = 32.4;

        elem('applejuice0bar').style.width = ((modul1.resistance.applejuice0 / modul1.resistance.water0)*maxWidth).toFixed(1) + "%";
        elem('beer0bar').style.width = ((modul1.resistance.beer0 / modul1.resistance.water0)*maxWidth).toFixed(1) + "%";
        elem('applejuice1bar').style.width = ((modul1.resistance.applejuice1 / modul1.resistance.water1)*maxWidth).toFixed(1) + "%";
        elem('beer1bar').style.width = ((modul1.resistance.beer1 / modul1.resistance.water1)*maxWidth).toFixed(1) + "%";

        /*
        elem('waterbar0').style.width = "50%";
        elem('applejuicebar0').style.width = ((modul1.resistance.applejuice0 / modul1.resistance.water0)*50).toFixed(1) + "%";
        elem('beerbar0').style.width = ((modul1.resistance.beer0 / modul1.resistance.water0)*50).toFixed(1) + "%";

        elem('waterbar1').style.width = "50%";
        elem('applejuicebar1').style.width = ((modul1.resistance.applejuice1 / modul1.resistance.water1)*50).toFixed(1) + "%";
        elem('beerbar1').style.width = ((modul1.resistance.beer1 / modul1.resistance.water1)*50).toFixed(1) + "%";*/
    },

    exp2: {
        init: false,
        plot: undefined,
        plotDataA: undefined,
        plotDataB: undefined,
        step: 0,
        voltage: 2.8,
        row: 0,
        series: 0,
        timer: undefined,

        enter() {
            console.log('B');
            modul1.exp2.timer = document.getElementById('sm-exp2-timer');
            sm.timer.setStartSeconds(modul1.exp2.timer, 10);

            if (modul1.exp2.init == false) {
                modul1.exp2.updatePosition();
                modul1.exp2.nextStep();

                modul1.exp2.plot = elem('plot');
                modul1.exp2.plotDataA = elem('water');
                modul1.exp2.plotDataB = elem('other');

                modul1.exp2.init = true;
            }
        },


        updatePosition() {
            var childOffset = elem('row-' + modul1.exp2.series + '-' + modul1.exp2.row).getBoundingClientRect();
            var parentOffset = elem('column-0').getBoundingClientRect();
            var container = document.getElementById('sm-interactionContainer');
            container.style.top = (childOffset.top - parentOffset.top) + 'px';
        },

        nextStep() {
            var newCommand = '';

            switch (modul1.exp2.step) {
                case 0:
                    newCommand = 'Fill in the sensor resistance';
                    if (modul1.exp2.row == 10) {
                        if (modul1.exp2.series == 0) {
                            modul1.exp2.series = 1;
                            modul1.exp2.voltage = 3;
                            modul1.exp2.step = 3;
                            modul1.exp2.row = -1;
                        } else {
                            modul1.exp2.step = 5;
                        }
                    } else {
                        modul1.exp2.step = 1;
                    }
                    modul1.exp2.row = modul1.exp2.row + 1;
                    document.getElementById('sm-nextStepButton').disabled = false;
                    break;
                case 1:
                    modul1.exp2.voltage = modul1.exp2.voltage - 0.2;
                    newCommand = 'Adjust the heating voltage to <span style="white-space:nowrap"><i>U</i> = ' + modul1.exp2.voltage.toFixed(1).replace('.',',') + ' V</span>';
                    if (modul1.exp2.voltage == 2.8 && modul1.exp2.series == 1) {
                        modul1.exp2.step = 4;
                    } else {
                        modul1.exp2.step = 2;
                    }
                    modul1.exp2.updatePosition();
                    break;
                case 2:
                    newCommand = 'Wait 10s';
                    sm.timer.setStartSeconds(modul1.exp2.timer, 10);
                    sm.timer.start(modul1.exp2.timer);
                    document.getElementById('sm-nextStepButton').disabled = true;
                    modul1.exp2.step = 0;
                    break;
                case 3:
                    newCommand = 'Unscrew the glass of water and then screw the glass with the inscription <i>' + modul1.choice + '</i> onto the circuit board.';
                    modul1.exp2.step = 1;
                    modul1.exp2.updatePosition();
                    break;
                case 4:
                    newCommand = 'Wait 30s!'
                    sm.timer.setStartSeconds(modul1.exp2.timer, 30);
                    sm.timer.start(modul1.exp2.timer);
                    document.getElementById('sm-nextStepButton').disabled = true;
                    modul1.exp2.step = 0;
                    break;
                case 5:
                    newCommand = 'The measurement is complete. Continue with <i>Continue</i>.';
                    document.getElementById('sm-nextStepButton').disabled = true;
                    elem('column-0').classList.remove('sm-uncomplete');
                    sm.page.checkCompleted();
                    break;
            }

            document.getElementById('sm-command').innerHTML = newCommand;
        },

        tick() {
            
        },

        changeA(input, i) {
            if (input.value == '') {
                modul1.exp2.plotDataA._points[i][1] = -100;
            } else {
                modul1.exp2.plotDataA._points[i][1] = parseFloat(input.value);
                sm.plot.data.update(modul1.exp2.plotDataA);
            }
        },

        changeB(input, i) {
            if (input.value == '') {
                modul1.exp2.plotDataB._points[i][1] = -100;
            } else {
                modul1.exp2.plotDataB._points[i][1] = parseFloat(input.value);
                sm.plot.data.update(modul1.exp2.plotDataB);
            }
        }
    },

    overview: {
        enter() {
            sm.plot.update(elem('plot'));
        }
    }
};